package nl.kallestruik.dtweaks.commands

import co.aikar.commands.BaseCommand
import co.aikar.commands.annotation.*
import nl.kallestruik.dtweaks.BundleColor
import nl.kallestruik.dtweaks.BundleVariant
import nl.kallestruik.dtweaks.tweaks.miscellaneoustweaks.BetterBundles
import org.bukkit.Material
import org.bukkit.entity.Player
import org.bukkit.persistence.PersistentDataType

@CommandAlias("bundle")
@Conditions("tweakEnabled:tweak=BetterBundles")
class CommandBundle(
    private val betterBundles: BetterBundles,
): BaseCommand() {
    @Subcommand("variant")
    fun onVariant(sender: Player, variant: BundleVariant) {
        val bundle = sender.inventory.itemInMainHand
        if (bundle.type != Material.BUNDLE)
            return

        val bundleMeta = bundle.itemMeta
        bundleMeta.persistentDataContainer.set(betterBundles.VARIANT_KEY, PersistentDataType.STRING, variant.toString())
        bundle.itemMeta = bundleMeta
        betterBundles.updateBundle(bundle)
    }

    @Subcommand("color")
    fun onVariant(sender: Player, color: BundleColor) {
        val bundle = sender.inventory.itemInMainHand
        if (bundle.type != Material.BUNDLE)
            return

        val bundleMeta = bundle.itemMeta
        bundleMeta.persistentDataContainer.set(betterBundles.COLOR_KEY, PersistentDataType.STRING, color.toString())
        bundle.itemMeta = bundleMeta
        betterBundles.updateBundle(bundle)
    }
}