package nl.kallestruik.dtweaks.fakeplayer

import io.netty.util.concurrent.Future
import io.netty.util.concurrent.GenericFutureListener
import net.minecraft.network.chat.Component
import net.minecraft.network.chat.TranslatableComponent
import net.minecraft.network.protocol.Packet
import net.minecraft.server.MinecraftServer
import net.minecraft.server.network.ServerGamePacketListenerImpl
import javax.annotation.Nullable

class FakePlayerConnection(
    minecraftServer: MinecraftServer,
    connection: FakeConnection,
    player: FakePlayer
): ServerGamePacketListenerImpl(minecraftServer, connection, player) {
    override fun send(packetIn: Packet<*>?) {}
    override fun send(packet: Packet<*>, listener: GenericFutureListener<out Future<in Void>>?) {}

    override fun disconnect(message: Component) {
        if (message is TranslatableComponent && (message.key.equals("multiplayer.disconnect.idling") || message.equals("multiplayer.disconnect.duplicate_login")))
        {
            player.kill()
        }
    }

    override fun tick() {
        println("Tick for ${player.name}")
        super.tick()
    }
}